# Changelog

All notable changes to the Schematron Rules and this project will be documented in this file.

The format is based on [Keep a Changelog](https://keepachangelog.com/en/1.1.0/)
and this project adheres to [Semantic Versioning](https://semver.org/spec/v2.0.0.html).

## v0.9.5 - 2025-04-09

* This release is compatible with eForms-DE 2.0.0

### Added

* Codelist `procurement-procedure-type` related replacement rules: `DE-BR-BT-00105-0126`,
  `DE-BR-BT-00105-0145`, `DE-BR-BT-00050-0016`, `DE-BR-BT-00050-0022`, `DE-BR-BT-00661-0012`,
  `DE-BR-BT-00661-0022`, `DE-BR-BT-00050-0102`, `DE-BR-BT-00052-0012`, `DE-BR-BT-00052-0022`,
  `DE-BR-BT-00098-0012`, `DE-BR-BT-00098-0022`, `DE-BR-BT-00120-0022`, `DE-BR-BT-00120-0052`. #121
* To `ted-excluded-rules.txt` the EU rules regarding `procurement-procedure-type` code 
  values that now have replacement rules defined. #121


## v0.9.4 - 2025-02-26

* This release is compatible with eForms-DE 2.0.0

### Changed

* Replacement rule `DE-BR-BT-00145-0036` is fixed: condition regarding values for
  `procurement-procedure-type` code values was incorrect. #117
* Rules `CR-DE-BT-760-LotResult` and `SR-DE-22` are fixed: condition regarding code value `open-nw`
  for BT-142 is added. #118


## v0.9.3 - 2024-12-18

* This release is compatible with eForms-DE 2.0.0

### Changed

* Rule `BT-735-Lot` is replaced with two rules: `BT-735-Lot-exists` and `BT-735-Lot-empty` to work 
  with repeated values for BT-735-Lot. #112
* Rule `BR-DE-23` is improved by making context/variable conditions more strict, so that not all 
  repeated values would be caught by the rule. #112
* Rule `BR-DE-30` is improved by using function exists which allows multiple values for BT-821. #112


## v0.9.2 - 2024-11-27

* This release is compatible with eForms-DE 2.0.0

### Changed

* Rule `CR-DE-BT-772-Lot` to avoid conflict with EU rules in case BT-771-Lot has value 
  `late-none`. #110
* Rule `DE-BR-BT-01311-0022` to be applied for all the needed subtypes according to the replaced EU 
  rules. #111


## v0.9.1 - 2024-10-10

* This release is compatible with eForms-DE 2.0.0

### Removed

* Codelist `eforms-de-specific-legal-basis` related replacement rules: `DE-BR-BT-00001-0210`,
  `DE-BR-BT-00001-0211`, `DE-BR-BT-00001-0212`, `DE-BR-BT-00001-0223` as they are regarding 
  `RegulatoryDomain` where German codelist values should not be used #106
* from `ted-excluded-rules.txt` the EU rules regarding RegulatoryDomain codelist values #106


## v0.9.0 - 2024-09-02

* This release is compatible with eForms-DE 2.0.0

### Added

* Rule `BR-DE-30`: If 'Procurement Document' is selected for BT-821, a description including a 
  Deeplink must be specified in BT-750. #95
* Rule `BR-DE-31`: The field length is limited to 5 digits. #96
* Rule `CL-DE-BT-682` related to the new tailored codelist `foreign-subsidy-measure-conclusion`  
* Codelist `eforms-de-specific-legal-basis` related replacement rules: `DE-BR-BT-00001-0210`,
  `DE-BR-BT-00001-0211`, `DE-BR-BT-00001-0212`, `DE-BR-BT-00001-0223`
* Codelist `procurement-procedure-type` related replacement rules: `DE-BR-BT-00040-0012`,
  `DE-BR-BT-00040-0022`, `DE-BR-BT-00106-0053`, `DE-BR-BT-00106-0022`, `DE-BR-BT-00106-0037`,
  `DE-BR-BT-00106-0023`, `DE-BR-BT-00106-0038`, `DE-BR-BT-00106-0024`, `DE-BR-BT-00136-0037`,
  `DE-BR-BT-00136-0059`, `DE-BR-BT-00135-0037`, `DE-BR-BT-00135-0059`
* assert attributes `ted-fields`, `on-terms` and `requires` for reference to BT and field ids #94

### Changed

* Codelist-rules updated to [eforms-de-codelist](https://projekte.kosit.org/eforms/eforms-de-codelist) v2024-09-02 (compatible with eForms-DE 2.0 and TED SDK 1.12.0)
* Updated `ted-excluded-rules.txt`

### Removed

* Replacement rules `DE-BR-BT-00002-0100`, `DE-BR-BT-00002-0102`, `DE-BR-BT-00105-0110`, 
  `DE-BR-BT-00105-0112`, `DE-BR-BT-00105-0111` based on changes on original rules in 
  eforms-sdk-1.12.0 as code values are no longer used

### Fixed

* Additional rule added to check if BT-300 exists for the rule `BR-DE-26` #93, #103

## v0.8.4

* This release is compatible with eForms-DE 1.2.0

### Removed

* Removed rule `SR-DE-11-a` (required `cac:Country` in Place of Performance) as it is no longer 
  compatible with SDK-EU semantic change #91.

## v0.8.3

* This release is compatible with eForms-DE 1.2.0

### Fixed

* Replacement rules for the SDK-EU rules conflicting with German tailoring of `BT-11`
  (which are added to `ted-excluded-rules.txt`): `DE-BR-BT-00010-A`, `DE-BR-BT-00010-B` and
  `DE-BR-BT-00740-0101` #86.

## v0.8.2

* This release is compatible with eForms-DE 1.2.0

### Fixed

* Not having included the updated `ted-excluded-rules.txt` (relates to discussion in #84) as promised in 0.8.1

## v0.8.1

* This release is compatible with eForms-DE 1.2.0

### Added

* Set of SDK-EU rules conflicting with german tailoring of `BT-11` to `ted-excluded-rules.txt` (relates to discussion in #84) 

### Fixed

* Adjusted rule id to `CR-DE-BT-15`
* Fix rule `CR-DE-BT-708` to use `ext:UBLExtensions/ext:UBLExtension/ext:ExtensionContent/efext:EformsExtension/efac:OfficialLanguages/cac:Language/cbc:ID` instead of `cbc:LanguageID` #81

### Removed

* Rules `CR-DE-BT-5141` and `SR-DE-15`,`BR-DE-27-Lot` and `BR-DE-27-Part`. The busines rule is covered by SDK-EU since 1.10.x on which this eForms-DE 1.2 relies. #83
* Rule `CR-DE-BT-512` (required `cbc:PostalZone`) as it is now enforced by SDK-EU `BR-BT-00512-0004` ff. #82

## v0.8.0

* This release is compatible with eForms-DE 1.2.0

### Added

### Added 

* Valid eForms-DE examples for all notice types #73
* Rule `CR-DE-OPT-030`: Der Wert `ted-esen` ist als Rolle und Subrolle verboten #56

### Changed

* Codelist-rules updated to [eforms-de-codelist](https://projekte.kosit.org/eforms/eforms-de-codelist) v2024-02-02 (compatible with eForms-DE 1.2 and TED SDK 1.10.1) #75
* Syntax for `BT-300` (`<cbc:Note>`) if `BT-726` (`<cbc:SMESuitableIndicator>`)is `true` #53
  * Added code `other-sme`
  * Allows multiple values
  * Works on all main languages (`<cbc:NoticeLanguageCode>`) in all combinations with additional languages 
  * Syntax MUST be given in at least the `<cbc:Note>` with `@languageID = cbc:NoticeLanguageCode`

### Fixed

* Corrected list of allowed subtypes for `BT-105` #74
* `SR-DE-3` only allows notice types supported by eForms-DE ( 1,2,3, E1 and E5 are forbidden now) #78


## v0.7.2 - 2023-12-12

* This release is compatible with eForms-DE 1.1.0

### Removed

* Rule `BR-DE-25`


## v0.7.1 - 2023-12-11

* This release is compatible with eForms-DE 1.1.0

### Fixed

* Rule `BR-DE-26` only if `cbc:Note[./@languageID = 'DEU']`
* Rule `BR-DE-23` requires `BT-734` (`cbc:Name`) in main language of `BT-702`

* Rule `CR-DE-BT-500` requires `BT-734` (`cbc:Name`) in main language of `BT-702`
* Rules `CR-DE-BT-21{-Lot,-Part,-LotsGroup}` require `BT-734` (`cbc:Name`) in main language of `BT-702`
* Rule `CR-DE-BT-772-Lot` requires `BT-734` (`cbc:Name`) in main language of `BT-702`

### Added

* Test file `eforms_CN_16_multilang.xml` for tests on rules effected by multi-language usage

## v0.7.0 - 2023-11-17

* This release is compatible with eForms-DE 1.1.0

### Added

* Dynamic rule phase and pattern for time dependent validation #57
* TED rule BR-BT-00005-0150 to blacklist #55
* `SR-BT-738-1` and `SR-BT-738-P60D` as replacement for `BR-BT-00738-0053` #50 #52
* List of TED rules/assertions to be excluded from validation

### Fixed

* Rule `CR-DE-BT-165` applies to correct set of notice subtypes #59
* Remove `SR-DE-33` #54
* Remove `SR-DE-24` #47

## v0.6.0 - 2023-07-31

* This release is compatible with eForms-DE 1.1.0

### Added

* `BR-DE-20` (BT-6 CM Rule) #31
* `BR-DE-21` and `BR-DE-22` (BT-6 occurence rules) #32
* `BR-DE-23` (weight criteria) #33
* `BR-DE-24` (CM for CVD) #34
* `BR-DE-25` (UBO nationality) #35
* `BR-DE-26` (Besonders geeignet für KMU") #36
* `BR-DE-27` and `BR-DE-28` (Nuts-Code conditional mandatory) #37

### Changed

* Rules updated to eforms-de-codelist v2023-07-07
* `CR-DE-BT-105` mandatory  
* `CR-DE-BT-165` mandatory for 25-37 if is Winner
* `CR-DE-BT-717-Lot` mandatory
* Updated many tests

### Fixed

* `SR-DE-14` cac:RealizedLocation repeatable now #45

## v0.5.2

This release is compatible with eForms-DE 1.0.1

### Fixed

* `SR-DE-11` `cac:RealizedLocation` repeatable now #46
* `CR-DE-BT-706-UBO` only on notice types `'25', '26', '27', '28', '29', '30', '31', '32', 'E4', '33', '34', '35', '36', '37'`

## v0.5.1

This release is compatible with eForms-DE 1.0.1

### Added

* Various more tests

### Fixed

* Rules `CR-DE-BT-771-Lot` and `CR-DE-BT-772-Lot` to only apply in this case `cac:TendererQualificationRequest[not(cbc:CompanyLegalFormCode)]/cac:SpecificTendererRequirement[(cbc:TendererRequirementTypeCode[@listName = 'missing-info-submission'])]` #26 #28
* Rule `CL-DE-BT-11`: Wrong code `kbeh` is now `kommun-beh` #22
* Rule `CR-DE-BT-15-Lot` and `CR-DE-BT-15-Part` only mandatory for `non-restricted-document`(s) #18
* Rule `CR-DE-BT-760-LotResult` better validates `efac:ReceivedSubmissionsStatistics/efbc:StatisticsCode` #25

### Changed

* Add code `CrossBorderLaw` to `CL-DE-BT-01` in order to allow ambiguous use of `cac:ProcurementLegislationDocumentReference/cbc:ID` for other BTs. #27
* Make consistent use of @rule="error"

### Added

* Sanity rules `SR-DE-23` and `SR-DE-24` for robustness of `BT-15` rules

## v0.5.0

This release is compatible with eForms-DE 1.0.1

### Added

* Schematron Rules
  * For tailored code lists
* Testing
  * &gt; 500 test cases covering all rules

### Changed

* Completely revised rules on cardinality
