# eForms-DE Test approach

The general test approach is based on the fact that we use XML-Mutate [TODO: add reference]. This allows us to keep a minimal set of **valid original** test instances, because most of the test cases (valid and invalid variants) are automatically generated, tested, and evaluated by XML Mutate.

Hence, it follows that first rule is:

> Do NOT create an instance per test case

> Instead add as many test cases to a single instance as possible

## What is the minimal set of originals?

They way to lower the number of originals for eForms-DE is to find for each phase the best representative notice type (rnt). 

For PIN (prior information notice):
For CN (completion notice):
For CAN (Contract award notice):

* Each rnt best represents a real world scenario.
* Also add other instances for real world scenarios e.g. a complete procedure chain of notices incl. PIN, CN, CAN

## Derive and manage test instances

The more technical the tests are the more it only requires to choose a rnts.

Hence, copy the original rnt and add as many xmute isntructions as possible.

Name this files `eforms-DE_{PIN,CN,CAN}_${SUBTYPE}_{min,max}?_codelists.xml` 

## Current Status

it is a mess

Issues:

* Too many test files
* Too many test files not validating

## Road to improvements

* Maintain and minimize originals (see above)

see codelists README

Algorithm:

Given a minimal set of originals:

For each Rule 
  * choose the rnts for all phases for which the rule is relevant 
   * If the rule needs special testing with/in other subtypes, use it and document well why 
 

 ## Tips for designing test cases

 * If using normalize-space() or other functions which only accept one single node the ask the following questions:
   * Do we have made sure that it only can exist once (tested by ither rule)? 
   * Or is the XPath guarantied to always only return one node? Test it with an exmaple where several nodes could theoricallz be selected? example of such issues https://projekte.kosit.org/eforms/eforms-de-schematron/-/issues/112 


